#include <bits/stdc++.h>
using namespace std;
int main()
{
    int k,x,y;
    int w,h,r,q;
    cin>>w>>h>>r>>q;
    long double a[w+1];
    for(int i=0;i<=w;++i)a[i]=1.0*h;
    while(q--)
    {
        cin>>k;
        if(k==2)
        {
            cin>>x;
            cout<<a[x]<<endl;
        }
        if(k==1)
        {
            cin>>x>>y;
            for(int i=max(0,x-r);i<=min(w,x+r);++i)
            {
                int dx=abs(x-i);
                if(y-sqrt(r*r-dx*dx)<a[i])
                    a[i]=y-sqrt(r*r-dx*dx);
            }
        }
    }
}